<?php
require_once(dirname(__FILE__).'../../mpaycallerservice.php');
class MyanpayConfirmModuleFrontController extends ModuleFrontController

{
	public $display_column_left = false;
	public function initContent()
	{		
		if (!$this->context->customer->isLogged() || empty($this->context->cart))
			Tools::redirect('index.php');
			
				parent::initContent();
				$this->myanpay = new Myanpay();
				$this->context = Context::getContext();
				
				$this->id_module = (int)Tools::getValue('id_module');
				
				$currency = new Currency((int)$this->context->cart->id_currency);
				$currencies_module = Currency::getCurrency((int)$this->context->cart->id_currency);
				
		if(isset($_REQUEST['token']))
		{
			$nvpstr = "&apiusername=" . Configuration::get('MYANPAY_API_USERNAME') .
			"&apipassword=" . Configuration::get('MYANPAY_API_PASSWORD') .
			"&apisignature=" . Configuration::get('MYANPAY_API_SIGNATURE') .
			"&version=1.1" .
			"&TOKEN=" . urlencode($_REQUEST['token']);
			
			$resArray=hash_call("GetExpressCheckout",$nvpstr,Configuration::get('MYANPAY_MODE'));
			//var_dump($resArray);
			//exit;
			$cookie = Context::getContext()->cookie;
			$cookie->getAmt = $resArray["PaymentRequest_ItemTotalAmt"];

			if (isset($resArray["mpayerr"]) && ($resArray["mpayerr"] == "ErrorOccur"))
			{
				$msgTitle = ' The MyanPay Payment Server has returned an error! ';
				$mpayerrmsg1 = ' Error No &nbsp; :: &nbsp; &nbsp;' . $resArray["mpayerrNo"];	
				$mpayerrmsg2 = ' Message &nbsp; :: &nbsp; &nbsp;' . $resArray["mpayerrMsg"];
				$mpayerrmsg = array($mpayerrmsg1,$mpayerrmsg2);													
				$this->context->smarty->assign(array(
					'logs' => $mpayerrmsg,
					'message' => $msgTitle
				));
				$this->setTemplate('order-message.tpl');
				
			} else  {
				$ack = strtoupper($resArray["Ack"]);
				$w = 0;
				if($ack=="SUCCESS")
				{	
				/*$reference = Order::generateReference();
				$this->reference = $reference;
				$order = new Order();
				$order->id_order = $this->reference;
			*/
				//$module_instance = Module::getInstanceByName('myanpay');
				
					$this->context->smarty->assign(array(
					'form_action' => Tools::getShopDomainSsl(true, true).__PS_BASE_URI__.'index.php?fc=module&module=myanpay&controller=validation',
					'arr'=> $resArray,
					'total' => $resArray["PaymentRequest_Amt"],
					'logos' => 'modules/myanpay/img/myanpaylogo.png',			
					'payerId' => $_REQUEST['payerId'],
					'token' => $_REQUEST['token'],	
					'Name' => $resArray["DisplayName"],
					'Email' => $resArray["PrimaryEmailAddress"],
					'Phone' => $resArray["PhoneNumber"],
					'Status' => $resArray["PayerStatus"],
					'Login' => $resArray["Ack"],
					'Time' => $resArray["TimeStamp"],
					//'MpayErr' => $resArray["LONGMESSAGE0"]
					));		
					
					$this->setTemplate('order-summary.tpl');

				
				} else if($ack=="FAIL") {
					
					$msgTitle = ' The MyanPay Payment Server has returned an error! ';
					foreach($resArray as $key => $value)
					{
						$nvpErr[] = $key . ' :: ' . $value;
					}
					$this->context->smarty->assign(array(
						'logs' => $nvpErr,
						'message' => $msgTitle
					));
					$this->setTemplate('order-message.tpl');
					
				} else  {
					
					$msgTitle = ' Unable to Establish MyanPay Payment Server! ';
					$mpayerrmsg1 = ' Your request cannot be completed because the service could not be found or did not respond. ';	
					$mpayerrmsg2 = ' Please try again for your payment process.';
					$mpayerrmsg = array($mpayerrmsg1,$mpayerrmsg2);
													
					$this->context->smarty->assign(array(
						'logs' => $mpayerrmsg,
						'message' => $msgTitle
					));
					$this->setTemplate('order-message.tpl');
				}
				
			}
		}
	}
}
