<?php

function hash_call($methodName,$nvpStr,$urlMode)
{
	//setting the curl parameters.
	$ch = curl_init();
	if ($urlMode == "1") 
	{		
		if ($methodName == "SetExpressCheckout") 
		{
			curl_setopt($ch, CURLOPT_URL,"https://www.myanpay.com.mm/Personal/ExpressCheckout/ExpressCheckoutRequestHandler.aspx");
		} else if($methodName == "GetExpressCheckout") {
			curl_setopt($ch, CURLOPT_URL,"https://www.myanpay.com.mm/Personal/ExpressCheckout/GetExpressCheckoutRequestHandler.aspx");
		} else if($methodName == "DoExpressCheckout") {
			curl_setopt($ch, CURLOPT_URL,"https://www.myanpay.com.mm/Personal/ExpressCheckout/DoExpressCheckOutRequestHandler.aspx");
		} else {
			curl_setopt($ch, CURLOPT_URL,"https://www.myanpay.com.mm/Personal/ExpressCheckout/ExpressCheckoutRequestHandler.aspx");
		}
		
	} else {

		if ($methodName == "SetExpressCheckout") 
		{
			curl_setopt($ch, CURLOPT_URL,"https://www.myanpay-virtualbox.com/Personal/ExpressCheckout/ExpressCheckoutRequestHandler.aspx");
		} else if($methodName == "GetExpressCheckout") {
			curl_setopt($ch, CURLOPT_URL,"https://www.myanpay-virtualbox.com/Personal/ExpressCheckout/GetExpressCheckoutRequestHandler.aspx");
		} else if($methodName == "DoExpressCheckout") {
			curl_setopt($ch, CURLOPT_URL,"https://www.myanpay-virtualbox.com/Personal/ExpressCheckout/DoExpressCheckOutRequestHandler.aspx");
		} else {
			curl_setopt($ch, CURLOPT_URL,"https://www.myanpay-virtualbox.com/Personal/ExpressCheckout/ExpressCheckoutRequestHandler.aspx");
		}

	}
	
	curl_setopt($ch, CURLOPT_VERBOSE, 1);

	//turning off the server and peer verification(TrustManager Concept).
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch, CURLOPT_POST, 1);
	
	$nvpreq="METHOD=".urlencode($methodName).$nvpStr;
	
	//setting the nvpreq as POST FIELD to curl
	curl_setopt($ch,CURLOPT_POSTFIELDS,$nvpreq);

	//getting response from server
	$response = curl_exec($ch);

	//convrting NVPResponse to an Associative Array
	$nvpResArray=deformatNVP($response);
	$nvpReqArray=deformatNVP($nvpreq);
	
	if (curl_errno($ch)) 
	{
		$nvpResArray =	array(
			'mpayerr' => 'ErrorOccur',
			'mpayerrNo' => curl_errno($ch),
			'mpayerrMsg' => curl_error($ch)
		);
	 } else {
		curl_close($ch);
	  }	
	  return $nvpResArray;
}

/** This function will take NVPString and convert it to an Associative Array and it will decode the response.
  * It is usefull to search for a particular key and displaying arrays.
  * @nvpstr is NVPString.
  * @nvpArray is Associative Array.
  */

function deformatNVP($nvpstr)
{
	$intial=0;
 	$nvpArray = array();

	while(strlen($nvpstr))
	{
		//postion of Key
		$keypos= strpos($nvpstr,'=');
		//position of value
		$valuepos = strpos($nvpstr,'&') ? strpos($nvpstr,'&'): strlen($nvpstr);

		/*getting the Key and Value values and storing in a Associative Array*/
		$keyval=substr($nvpstr,$intial,$keypos);
		$valval=substr($nvpstr,$keypos+1,$valuepos-$keypos-1);
		//decoding the respose
		$nvpArray[urldecode($keyval)] =urldecode( $valval);
		$nvpstr=substr($nvpstr,$valuepos+1,strlen($nvpstr));
     }
	return $nvpArray;
}

?>
