<style>
table.tblmpay {
	background: none repeat scroll 0 0 #EAEBEC;
	border: 1px solid #CCCCCC;
	border-radius: 3px 3px 3px 3px;
	box-shadow: 0 1px 2px #D1D1D1;
	color: #666666;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	margin: 10px;
	text-shadow: 1px 1px 0 #FFFFFF;
	border-spacing: 0;
	border-collapse: inherit;
}
table.tblmpay th {
	background: -moz-linear-gradient(center top, #EDEDED, #EBEBEB) repeat scroll 0 0 transparent;
	border-bottom: 1px solid #E0E0E0;
	border-top: 1px solid #FAFAFA;
	padding: 10px 0px 10px 20px;
}
table.tblmpay td {
	background: -moz-linear-gradient(center top, #FBFBFB, #FAFAFA) repeat scroll 0 0 transparent;
	border-bottom: 1px solid #E0E0E0;
	border-left: 1px solid #E0E0E0;
	border-top: 1px solid #FFFFFF;
	padding: 5px 0px 5px 10px;
}
</style>

{if $smarty.const._PS_VERSION_ < 1.5 && isset($use_mobile) && $use_mobile}
	{include file="$tpl_dir./modules/myanpay/views/templates/front/order-summary.tpl"}
{else}
	{capture name=path}{l s='Order Summation' mod='myanpay'}{/capture}
    <h1>{l s='Order Summary' mod='myanpay'}</h1>
    <br>
{assign var='current_step' value='payment'}
	{include file="$tpl_dir./order-steps.tpl"}
    <h3>{l s='MyanPay Payment' mod='myanpay'}</h3>
    
   <form action="{$form_action}" method="post" data-ajax="false">
  <input type="hidden" name="payerId" value="{$payerId}" />
  <input type="hidden" name="token" value="{$token}" />
  <input type="hidden" name="total" value="{$total}" />
  <input type="hidden" name="arr" value="{$arr}" />
  <br />
  <div id="order-detail-content" class="table_block table-responsive">
        <table width="100%" class="tblmpay" border="0" cellpadding="0" cellspacing="0">
            <thead>
                <tr>
                    <th class="cart_product first_item">Product</th>
                    <th class="cart_unit item text-left">Item Number</th>
                    <th class="cart_quantity item text-left">Qty</th>
                    <th class="cart_unit item text-center">Unit price</th>
                </tr>
            </thead>
              <tbody>
                        <tr>
                          <td> {assign var=w value=0}
                                {foreach $arr as $value}
                                {if $value@key eq PaymentRequest_ItemName|cat:$w}
                                <ul>
                              <li>{$value}</li>
                            </ul>
                                {assign var=w value=$w+1}
                                {/if}
                                {/foreach} 
                          </td>
                          <td> {assign var=e value=0}
                                {foreach $arr as $value}
                                {if $value@key eq PaymentRequest_ItemNumber|cat:$e}
                                <ul>
                              <li>{$value}</li>
                            </ul>
                                {assign var=e value=$e+1}
                                {/if}
                                {/foreach} 
                          </td>
                          <td> {assign var=f value=0}
                                {foreach $arr as $value}
                                {if $value@key eq PaymentRequest_ItemQty|cat:$f}
                                <ul>
                              <li>{$value}</li>
                            </ul>
                                {assign var=f value=$f+1}
                                {/if}
                                {/foreach} 
                          </td>
                          <td class="cart_unit item text-center"> {assign var=g value=0}
                                {foreach $arr as $value}
                                {if $value@key eq PaymentRequest_ItemAmt|cat:$g}
                                <ul>
                              <li>{$value}</li>
                            </ul>
                                {assign var=g value=$g+1}
                                {/if}
                                {/foreach} 
                         </td>
                    </tr>
                    <tr>
                      <td colspan="3" style="text-align:right;">Total</td>
                      <td class="cart_unit item text-center"> {$arr["PaymentRequest_ItemTotalAmt"]}</td>
                    </tr>
                 </tbody>
    	</table>
  </div>
  <br />
  <br />
  <div class="table_block table-responsive">
        <table width="100%" border="0" cellpadding="0" cellspacing="0">
      
            <td width="60%">
                <p> <img src="{$logos}" alt="{l s='MyanPay' mod='myanpay'}" style="float:left; margin: 0px 10px 5px 0px;" /> <br />
                {l s='You have chosen to pay with myanpay. Here is a short summary of your order:' mod='myanpay'}
                
                <p style="margin-top:5px;"> - {l s='The total amount of your order is' mod='myanpay'} <span id="amount" class="price"><strong>{$total}</strong></span> {if $use_taxes == 1}{l s='(tax incl.)' mod='myanpay'}{/if} </p>
                <p> - {l s='We accept the following currency to be sent by myanpay:' mod='myanpay'}&nbsp;<b>{$currency->name}</b> </p>
                <p> <b>{l s='Please confirm your order by clicking \'Pay With MyanPay\'' mod='myanpay'}.</b> </p>
          		</p>
          	</td>
            <td width="40%">
            	<table class="tblmpay" border="0" cellpadding="0" cellspacing="0">
                    <tr>
                        <th colspan="2"> <b> MyanPay Expresscheckout Information </b> </th>
                    </tr>
                    {if isset($MpayErr) }
                    <tr>
                        <td colspan="2"><b> The MyanPay API has returned an error on this order as following.. </b></td>
                     </tr>
                    <tr>
                        <td colspan="2" style="color:red;" > {$MpayErr} </td>
                     </tr>
                    {else}
                    <tr>
                        <td><b>Name</b></td>
                        <td> {$Name} </td>
                    </tr>
                    <tr>
                        <td><b>Email</b></td>
                        <td>{$Email}</td>
                    </tr>
                    <tr>
                        <td><b>Phone</b></td>
                        <td>{$Phone}</td>
                    </tr>
                    <tr>
                        <td><b>Status</b></td>
                        <td>{$Status}</td>
                    </tr>
                    <tr>
                        <td><b>Login</b></td>
                        <td>{$Login}</td>
                    </tr>
                    <tr>
                        <td><b> Login Time</b></td>
                        <td>{$Time}</td>
                     </tr>
                    {if $Status == 'Unverified'}
                    <tr>
                        <td colspan="2" style="color:red;"> Your MyanPay account is unverified. Please verified. </td>
                    </tr>
                    {/if}
                    
                    {/if}
              	</table>
            </td>
       </table>
   </div>
        <table width="100%">
        
            <td width="40%"></td>
            <td width="60%"><p class="cart_navigation"> {if isset($MpayErr) } <a style="width:135px; height:15px;" href="{$link->getPageLink('order', true, NULL, "step=3")}" class="button_large">{l s='Other payment methods' mod='myanpay' }</a> {else}
        {if $Status == 'Verified'}
            <input type="submit" name="confirmation" value="{l s='Pay With MyanPay' mod='myanpay'}" class="exclusive_large" />
        {else} <a style="width:135px; height:15px;" href="{$link->getPageLink('order', true, NULL, "step=3")}" class="button_large">{l s='Other payment methods' mod='myanpay' }</a> {/if}
        {/if} </p>
            </td>
        </table>
</form>
{/if} 